-----------------------------------------------------------------------------------
-- Maratis
-- effects.lua
-----------------------------------------------------------------------------------

-- GUI
Camera = getObject("Camera")
GUIScene = getScene("GUI")
enableCameraLayer(Camera, GUIScene)

-- pseudo particle system
Emitter = getObject("Emitter")
Particle = getObject("Particle")


-- particles functions
function getRandomDir(force)

	return {(math.random()-0.5)*force, (math.random()-0.5)*force, (math.random()-0.5)*force}

end

function initParticle(particle)

	size = 0.35 + math.random()
	life = math.max(0.25, math.random())

	setAnimationSpeed(particle, life) -- we use the animation speed to control the particle life
	changeAnimation(particle, 0)
	setCurrentFrame(particle, 0)

	clearForces(particle)
	setPosition(particle, getPosition(Emitter))
	setScale(particle, {size, size, size})
	addCentralForce(particle, getRandomDir(1))
	
end

function createParticle()

	particle = getClone(Particle)
	initParticle(particle)

	return particle
	
end

function addParticle()
	table.insert(particlesList, #particlesList + 1, createParticle())
end

function updateParticle(particle)

	if isAnimationOver(particle) then
		deactivate(particle)
	end

	if onKeyDown("SPACE") then

		activate(particle)
		initParticle(particle)

	end
	
end


-- create particle system (64 particles + 1)
particlesList = {Particle}

initParticle(Particle)

for i=1, 64 do
	addParticle()
end


-- scene update
function onSceneUpdate()

	for i=1, #particlesList do
		updateParticle(particlesList[i])
	end

end
